//	This source and compression method apply to GNU General Public License. 
//			Copyright (C) 2006 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			Genetic Text Complexity Display
//			written by Dzinleski Jasenko December,2005
//
//			to Maria Dzinleska



#include <stdio.h>
#include <string.h>
#include <math.h>

char	in1fn[256]="b.txt";
char	out1fn[256]="XXXXXX_.txt";

FILE *f1,*f2;

int	ba1[16][16][16][16];int	ba1i=0;
int	ba2[16][16][16][16];int	ba2i=0;
int	ba3[16][16][16][16];int	ba3i=0;
int	ba4[16][16][16][16];int	ba4i=0;
int	ba5[16][16][16][16];int	ba5i=0;
int	ba6[16][16][16][16];int	ba6i=0;

long	ca[0x00ffffff];int	cai=0;

int		da[30000][6+1];int	dai=0;

long	cr,ct,ci,cj;

int main()
{
	int		fbyte;
	int		i,j,k,l,n;
	int		b,c=0;
	int		a1,a2,a3,a4,a5,a6;
	int		b1,b2,b3,b4,b5,b6;

	long		a,m;

	bool	ef;

	char	fld[50][256];
	int		fi=0;
	int		fl[50];

	for(ci=0;ci<0x00ffffff;++ci){ca[ci]=-1;}
	for(i=0;i<30000;++i){da[i][0]=-1;}

	f1=fopen(in1fn,"rb");

	fbyte=getc(f1);
	while(!feof(f1))
	{
		fi=0;for(i=0;i<50;++i){fl[i]=0;for(j=0;j<256;++j){fld[i][j]='\0';}}
		while(!feof(f1)&&fbyte!=13&&fbyte!=10){if(fbyte==' '){fld[fi][fl[fi]]=fbyte;++fl[fi];++fi;}else{fld[fi][fl[fi]]=fbyte;++fl[fi];}fbyte=getc(f1);}
		while(!feof(f1)&&fbyte==13||fbyte==10){fbyte=getc(f1);}

		if(fi==8)
		{

			//for(i=0;i<=fi;++i){printf(".%d.%s",i,fld[i]);}
			//printf("\n");
			for(i=1;i<=6;++i)
			{
				for(j=0;j<fl[i];++j)
				{
					if(fld[i][j]>='A'&&fld[i][j]<='P')
					{
						if(fld[i][j]>'A')
						{
							for(k=12;k<=15;++k){if((((((fld[i][j]-65)&0x000f)<<k)>>15)&0x01)==1){k=15-k;break;}}
							//printf(".%d-%d.",j,k);
							if(i==1)
							{
								//printf(".%d-%d-%d-%d.",k,j,(j&0x0003),(((j&0x0003)<<2)|k));
								cr=((3-j)&0x0003)<<22;
								cr|=(k&0x0003)<<20;
								break;
							}
							if(i==2)
							{

								cr|=((3-j)&0x0003)<<18;
								cr|=(k&0x0003)<<16;
								break;
							}
							if(i==3)
							{
								
								cr|=((3-j)&0x0003)<<14;
								cr|=(k&0x0003)<<12;
								break;
							}
							if(i==4)
							{

								cr|=((3-j)&0x0003)<<10;
								cr|=(k&0x0003)<<8;
								break;
							}
							if(i==5)
							{

								cr|=((3-j)&0x0003)<<6;
								cr|=(k&0x0003)<<4;
								break;
							}
							if(i==6)
							{

								cr|=((3-j)&0x0003)<<2;
								cr|=(k&0x0003)<<0;

								if(ca[cr]==-1){ca[cr]=1;}else{++ca[cr];}

								break;
							}
						}

					}else{break;}
				}
			}


		}

	}
	fclose(f1);
	
	for(ci=0;ci<0x00ffffff;++ci){if(ca[ci]!=-1){++cai;}}printf(" Total x6 index groups.%d.\n",cai);	
	
	//return(0);

	m=0x00ffffff;c=0;
	while(c<cai)
	{

	++c;

	a=m;
	for(ci=0;ci<0x00ffffff;++ci)
	{
		if(ca[ci]!=-1)
		{
			if(a==m&&ca[ci]<m){a=ca[ci];}else{if(ca[ci]<m&&ca[ci]>a){a=ca[ci];ct=ci;}}
			//printf(".%d.",da[i][0]);
		}
	}
	m=a;

	printf("\n Sequence.%d.%d.%d.%d.%d.%d.\n",(ct&0x00f00000)>>20,(ct&0x000f0000)>>16,(ct&0x0000f000)>>12,(ct&0x00000f00)>>8,(ct&0x000000f0)>>4,(ct&0x0000000f)>>0);
	printf(" Sequence.%c.%c.%c.%c.%c.%c.\n",((ct&0x00f00000)>>20)+65,((ct&0x000f0000)>>16)+65,((ct&0x0000f000)>>12)+65,((ct&0x00000f00)>>8)+65,((ct&0x000000f0)>>4)+65,((ct&0x0000000f)>>0)+65);
	printf(" Sequence entries.%d.\n",a);
	
	for(i=0;i<30000;++i){da[i][0]=-1;}dai=0;
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l){ba1[i][j][k][l]=-1;}}}}ba1i=0;
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l){ba2[i][j][k][l]=-1;}}}}ba2i=0;
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l){ba3[i][j][k][l]=-1;}}}}ba3i=0;
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l){ba4[i][j][k][l]=-1;}}}}ba4i=0;
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l){ba5[i][j][k][l]=-1;}}}}ba5i=0;
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l){ba6[i][j][k][l]=-1;}}}}ba6i=0;

	f1=fopen(in1fn,"rb");

	fbyte=getc(f1);
	while(!feof(f1))
	{
		fi=0;for(i=0;i<50;++i){fl[i]=0;for(j=0;j<256;++j){fld[i][j]='\0';}}
		while(!feof(f1)&&fbyte!=13&&fbyte!=10){if(fbyte==' '){fld[fi][fl[fi]]=fbyte;++fl[fi];++fi;}else{fld[fi][fl[fi]]=fbyte;++fl[fi];}fbyte=getc(f1);}
		while(!feof(f1)&&fbyte==13||fbyte==10){fbyte=getc(f1);}

		if(fi==8)
		{

			//for(i=0;i<=fi;++i){printf(".%d.%s",i,fld[i]);}
			//printf("\n");
			for(i=1;i<=6;++i)
			{
				for(j=0;j<fl[i];++j)
				{
					if(fld[i][j]>='A'&&fld[i][j]<='P')
					{
						if(fld[i][j]>'A')
						{
							for(k=12;k<=15;++k){if((((((fld[i][j]-65)&0x000f)<<k)>>15)&0x01)==1){k=15-k;break;}}
							//printf(".%d-%d.",j,k);
							if(i==1)
							{
								
								cr=((3-j)&0x0003)<<22;
								cr|=(k&0x0003)<<20;
								//printf(".%d-%d-%d-%d.",k,j,(j&0x0003),(((j&0x0003)<<2)|k));
								//printf(".%d-%d-%d-%d-%d.",k,j,(j&0x0003),(((j&0x0003)<<2)|k),(int)((cr&0x00f00000)>>20));

								if((cr&0x00f00000)==(ct&0x00f00000))
								{
									if(ba1[-65+fld[1][0]][-65+fld[1][1]][-65+fld[1][2]][-65+fld[1][3]]==-1){ba1[-65+fld[1][0]][-65+fld[1][1]][-65+fld[1][2]][-65+fld[1][3]]=ba1i;a1=ba1i;++ba1i;}else{a1=ba1[-65+fld[1][0]][-65+fld[1][1]][-65+fld[1][2]][-65+fld[1][3]];}
								}
								break;
							}
							if(i==2)
							{

								cr|=((3-j)&0x0003)<<18;
								cr|=(k&0x0003)<<16;

								if((cr&0x00ff0000)==(ct&0x00ff0000))
								{
									if(ba2[-65+fld[2][0]][-65+fld[2][1]][-65+fld[2][2]][-65+fld[2][3]]==-1){ba2[-65+fld[2][0]][-65+fld[2][1]][-65+fld[2][2]][-65+fld[2][3]]=ba2i;a2=ba2i;++ba2i;}else{a2=ba2[-65+fld[2][0]][-65+fld[2][1]][-65+fld[2][2]][-65+fld[2][3]];}
								}
								break;
							}
							if(i==3)
							{

								cr|=((3-j)&0x0003)<<14;
								cr|=(k&0x0003)<<12;

								if((cr&0x00fff000)==(ct&0x00fff000))
								{
									if(ba3[-65+fld[3][0]][-65+fld[3][1]][-65+fld[3][2]][-65+fld[3][3]]==-1){ba3[-65+fld[3][0]][-65+fld[3][1]][-65+fld[3][2]][-65+fld[3][3]]=ba3i;a3=ba3i;++ba3i;}else{a3=ba3[-65+fld[3][0]][-65+fld[3][1]][-65+fld[3][2]][-65+fld[3][3]];}
								}
								break;
							}
							if(i==4)
							{

								cr|=((3-j)&0x0003)<<10;
								cr|=(k&0x0003)<<8;

								if((cr&0x00ffff00)==(ct&0x00ffff00))
								{
									if(ba4[-65+fld[4][0]][-65+fld[4][1]][-65+fld[4][2]][-65+fld[4][3]]==-1){ba4[-65+fld[4][0]][-65+fld[4][1]][-65+fld[4][2]][-65+fld[4][3]]=ba4i;a4=ba4i;++ba4i;}else{a4=ba4[-65+fld[4][0]][-65+fld[4][1]][-65+fld[4][2]][-65+fld[4][3]];}
								}
								break;
							}
							if(i==5)
							{

								cr|=((3-j)&0x0003)<<6;
								cr|=(k&0x0003)<<4;

								if((cr&0x00fffff0)==(ct&0x00fffff0))
								{
									if(ba5[-65+fld[5][0]][-65+fld[5][1]][-65+fld[5][2]][-65+fld[5][3]]==-1){ba5[-65+fld[5][0]][-65+fld[5][1]][-65+fld[5][2]][-65+fld[5][3]]=ba5i;a5=ba5i;++ba5i;}else{a5=ba5[-65+fld[5][0]][-65+fld[5][1]][-65+fld[5][2]][-65+fld[5][3]];}
								}
								break;
							}
							if(i==6)
							{

								cr|=((3-j)&0x0003)<<2;
								cr|=(k&0x0003)<<0;

								if((cr&0x00ffffff)==(ct&0x00ffffff))
								{
									if(ba6[-65+fld[6][0]][-65+fld[6][1]][-65+fld[6][2]][-65+fld[6][3]]==-1){ba6[-65+fld[6][0]][-65+fld[6][1]][-65+fld[6][2]][-65+fld[6][3]]=ba6i;a6=ba6i;++ba6i;}else{a6=ba6[-65+fld[6][0]][-65+fld[6][1]][-65+fld[6][2]][-65+fld[6][3]];}
								}

								if(cr==ct)
								{


									for(k=0;k<dai;++k)
									{
										if
										(
											da[k][1]==a1&&
											da[k][2]==a2&&
											da[k][3]==a3&&
											da[k][4]==a4&&
											da[k][5]==a5&&
											da[k][6]==a6
											){break;}
									}
									if(k==dai)
									{
										da[dai][0]=1;
										da[dai][1]=a1;
										da[dai][2]=a2;
										da[dai][3]=a3;
										da[dai][4]=a4;
										da[dai][5]=a5;
										da[dai][6]=a6;
										++dai;

									}else{++da[k][0];}
								}
								break;
							}
						}

					}else{break;}
				}
			}


		}

	}
	fclose(f1);

	printf("- pos 1. index entries.%d.\n",ba1i);	
	printf("- pos 2. index entries.%d.\n",ba2i);	
	printf("- pos 3. index entries.%d.\n",ba3i);	
	printf("- pos 4. index entries.%d.\n",ba4i);	
	printf("- pos 5. index entries.%d.\n",ba5i);	
	printf("- pos 6. index entries.%d.\n",ba6i);	
	
	out1fn[0]=((ct&0x00f00000)>>20)+65;
	out1fn[1]=((ct&0x000f0000)>>16)+65;
	out1fn[2]=((ct&0x0000f000)>>12)+65;
	out1fn[3]=((ct&0x00000f00)>> 8)+65;
	out1fn[4]=((ct&0x000000f0)>> 4)+65;
	out1fn[5]=((ct&0x0000000f)>> 0)+65;

	f2=fopen(out1fn,"w");
	for(n=0;n<dai;++n)
	{
		ef=false;for(i=0;i<16&&!ef;++i){for(j=0;j<16&&!ef;++j){for(k=0;k<16&&!ef;++k){for(l=0;l<16&&!ef;++l){if(ba1[i][j][k][l]==da[n][1]){a1=(i<<12)|(j<<8)|(k<<4)|(l<<0);ef=true;}}}}}
		ef=false;for(i=0;i<16&&!ef;++i){for(j=0;j<16&&!ef;++j){for(k=0;k<16&&!ef;++k){for(l=0;l<16&&!ef;++l){if(ba2[i][j][k][l]==da[n][2]){a2=(i<<12)|(j<<8)|(k<<4)|(l<<0);ef=true;}}}}}
		ef=false;for(i=0;i<16&&!ef;++i){for(j=0;j<16&&!ef;++j){for(k=0;k<16&&!ef;++k){for(l=0;l<16&&!ef;++l){if(ba3[i][j][k][l]==da[n][3]){a3=(i<<12)|(j<<8)|(k<<4)|(l<<0);ef=true;}}}}}
		ef=false;for(i=0;i<16&&!ef;++i){for(j=0;j<16&&!ef;++j){for(k=0;k<16&&!ef;++k){for(l=0;l<16&&!ef;++l){if(ba4[i][j][k][l]==da[n][4]){a4=(i<<12)|(j<<8)|(k<<4)|(l<<0);ef=true;}}}}}
		ef=false;for(i=0;i<16&&!ef;++i){for(j=0;j<16&&!ef;++j){for(k=0;k<16&&!ef;++k){for(l=0;l<16&&!ef;++l){if(ba5[i][j][k][l]==da[n][5]){a5=(i<<12)|(j<<8)|(k<<4)|(l<<0);ef=true;}}}}}
		ef=false;for(i=0;i<16&&!ef;++i){for(j=0;j<16&&!ef;++j){for(k=0;k<16&&!ef;++k){for(l=0;l<16&&!ef;++l){if(ba6[i][j][k][l]==da[n][6]){a6=(i<<12)|(j<<8)|(k<<4)|(l<<0);ef=true;}}}}}

		fprintf(f2,"%03d%c%03d%c%03d%c%03d%c%03d%c%03d\n",a1,(char)9,a2,(char)9,a3,(char)9,a4,(char)9,a5,(char)9,a6);
	}
	fclose(f2);

	
	}

	return(0);
}
