




//	This source and Genetic Text Complexity Display method apply to GNU General Public License. 
//			Copyright (C) 2001-2009 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			Genetic Text Complexity Display
//
//			written by Dzinleski Jasenko July,2010

#include 	<stdio.h>
#include 	<string.h>
#include 	<math.h>

int		pa[6];

char 		infn[256]="per_coid_all.txt";

FILE		*f1,*f2;

int main()
{
	int	i,j,k,l,m,n;
	int	a,b,c,d;
	int	fbyte;

	int		pg[100][2][6];	int	pgi=0;
	int		rs[6];
	int		rc[6];

	pa[0]='F';pa[1]='G';pa[2]='H';pa[3]='I';

	f1=fopen(infn,"rb");
	fbyte=getc(f1);
	while(!feof(f1))
	{
		i=0;while(!feof(f1)&&fbyte!=10&&fbyte!=13){rs[i]=fbyte;++i;fbyte=getc(f1);}
		while(!feof(f1)&&(fbyte==10||fbyte==13)){fbyte=getc(f1);}

		if(pgi==0)
		{
			pg[pgi][0][0]=rs[0];pg[pgi][1][0]=0;
			pg[pgi][0][1]=rs[1];pg[pgi][1][1]=0;
			pg[pgi][0][2]=rs[2];pg[pgi][1][2]=0;
			pg[pgi][0][3]=rs[3];pg[pgi][1][3]=0;
			pg[pgi][0][4]=rs[4];pg[pgi][1][4]=0;
			pg[pgi][0][5]=rs[5];pg[pgi][1][5]=0;

			for(j=0;j<6;++j)
			{
				if(pa[0]==rs[j]){++pg[pgi][1][0];continue;}
				if(pa[1]==rs[j]){++pg[pgi][1][1];continue;}
				if(pa[2]==rs[j]){++pg[pgi][1][2];continue;}
				if(pa[3]==rs[j]){++pg[pgi][1][3];continue;}
			}
			++pgi;

		}else{

			rc[0]=0;
			rc[1]=0;
			rc[2]=0;
			rc[3]=0;

			for(j=0;j<6;++j)
			{
				if(pa[0]==rs[j]){++rc[0];continue;}
				if(pa[1]==rs[j]){++rc[1];continue;}
				if(pa[2]==rs[j]){++rc[2];continue;}
				if(pa[3]==rs[j]){++rc[3];continue;}
			}
			
			for(i=0;i<pgi;++i)
			{
				if((pg[i][1][0]==rc[0])&&(pg[i][1][1]==rc[1])&&(pg[i][1][2]==rc[2])&&(pg[i][1][3]==rc[3])){break;}
			}
			if(i==pgi)
			{
				pg[pgi][0][0]=rs[0];pg[pgi][1][0]=0;
				pg[pgi][0][1]=rs[1];pg[pgi][1][1]=0;
				pg[pgi][0][2]=rs[2];pg[pgi][1][2]=0;
				pg[pgi][0][3]=rs[3];pg[pgi][1][3]=0;
				pg[pgi][0][4]=rs[4];pg[pgi][1][4]=0;
				pg[pgi][0][5]=rs[5];pg[pgi][1][5]=0;

				for(j=0;j<6;++j)
				{
					if(pa[0]==rs[j]){++pg[pgi][1][0];continue;}
					if(pa[1]==rs[j]){++pg[pgi][1][1];continue;}
					if(pa[2]==rs[j]){++pg[pgi][1][2];continue;}
					if(pa[3]==rs[j]){++pg[pgi][1][3];continue;}
				}
				++pgi;
			}

		}


	}fclose(f1);

	printf("%d\n",pgi);

	for(i=0;i<pgi;++i)
	{
		printf("%c\t%d\t",pa[0],pg[i][1][0]);
		printf("%c\t%d\t",pa[1],pg[i][1][1]);
		printf("%c\t%d\t",pa[2],pg[i][1][2]);
		printf("%c\t%d\t",pa[3],pg[i][1][3]);
		printf("\n");

		f1=fopen(infn,"rb");
		fbyte=getc(f1);
		while(!feof(f1))
		{
			l=0;while(!feof(f1)&&fbyte!=10&&fbyte!=13){rs[l]=fbyte;++l;fbyte=getc(f1);}
			while(!feof(f1)&&(fbyte==10||fbyte==13)){fbyte=getc(f1);}

			rc[0]=0;
			rc[1]=0;
			rc[2]=0;
			rc[3]=0;

			for(j=0;j<6;++j)
			{
				if(pa[0]==rs[j]){++rc[0];continue;}
				if(pa[1]==rs[j]){++rc[1];continue;}
				if(pa[2]==rs[j]){++rc[2];continue;}
				if(pa[3]==rs[j]){++rc[3];continue;}
			}

			if((rc[0]==pg[i][1][0])&&(rc[1]==pg[i][1][1])&&(rc[2]==pg[i][1][2])&&(rc[3]==pg[i][1][3]))
			{printf("%c%c%c%c%c%c\n",rs[0],rs[1],rs[2],rs[3],rs[4],rs[5]);}

		}fclose(f1);

	}


	return(0);

}

