


//	This source and compression method apply to GNU General Public License. 
//			Copyright (C) 2006 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			Genetic Text Complexity Display
//			written by Dzinleski Jasenko November,2010
//
//			to Maria Dzinleska




#include <stdio.h>
#include <string.h>
#include <math.h>

FILE	*f1;

char	infn[256]="res_all_1.txt";		

char	ss[256];	int	ssc=-1;		

//15
char	al11[256]="00050.68750";
char	au11[256]="00103.75000";
//16
char	al12[256]="00105.68750";
char	au12[256]="00171.50000";
//17
char	al13[256]="00064.87500";
char	au13[256]="00111.68750";
//18
char	al14[256]="00064.00000";
char	au14[256]="00108.25000";
//19
char	al15[256]="00080.18750";
char	au15[256]="00137.37500";
//20
char	al16[256]="00073.37500";
char	au16[256]="00118.00000";
//21
char	al17[256]="00089.25000";
char	au17[256]="00139.87500";
//22
char	al18[256]="00061.18750";
char	au18[256]="00104.25000";
//23
char	al19[256]="00106.50000";
char	au19[256]="00171.18750";
//24
char	al110[256]="00051.87500";
char	au110[256]="00098.37500";
//25
char	al111[256]="00019.68750";
char	au111[256]="00035.50000";
//26
char	al112[256]="00015.75000";
char	au112[256]="00031.00000";
//27
char	al113[256]="00015.75000";
char	au113[256]="00031.00000";
//28
char	al114[256]="00019.00000";
char	au114[256]="00031.75000";
//29
char	al115[256]="00022.50000";
char	au115[256]="00039.75000";
//30
char	al116[256]="00018.56250";
char	au116[256]="00031.75000";
//30
char	al117[256]="00018.56250";
char	au117[256]="00031.75000";
//30
char	al118[256]="00018.56250";
char	au118[256]="00031.75000";
//30
char	al119[256]="00018.56250";
char	au119[256]="00031.75000";


char	fld[5000][1024];
int		fi=0;
int		fl[5000];


double p_val(char arr0[256])
{

	int	j=0,k=0,l;

	long		fr;
	int		rvi;
	long		rvl;
	__int64	rvd;
	double		rvd_;

	char 		arr1[256];

	for(j=0;j<256;++j){arr1[j]='\0';}
	l=0;for(j=0;j<strlen(arr0);++j){if((arr0[j]>='0'&&arr0[j]<='9')||(arr0[j]=='.'||arr0[j]==',')){arr1[l]=arr0[j];++l;}}

	for(j=0;j<256;++j){arr0[j]='\0';}l=0;for(j=0;j<strlen(arr1);++j){arr0[l]=arr1[j];++l;}

	for(j=0;j<strlen(arr0);++j){if(arr0[j]=='.'){break;}}

	if(j==strlen(arr0))
	{
		rvl=0;l=-1;
		for(j=-1+strlen(arr0);j>=0;--j)
		{
			++l;rvl+=(long)(-48+arr0[j])*pow(10,l);
		}
		rvi=(int)rvl;
		rvd_=(double)rvl;

	}else{

			fr=0;l=-1;
			for(k=-1+strlen(arr0);k>j;--k)
			{
				++l;fr+=(long)(-48+arr0[k])*pow(10,l);
			}

			rvd=0;l=-1;
			for(k=j-1;k>=0;--k)
			{
				++l;rvd+=(__int64)(-48+arr0[k])*pow(10,l);

			}rvd*=(__int64)pow(10,strlen(arr0)-j-1);

			rvd_=(double)(rvd+(__int64)fr)/(__int64)pow(10,strlen(arr0)-j-1);
				
	}

	return(rvd_);
}

int	p_2(char scfn[256],int lv, int uv, char al[256], char au[256])
{

	char	p_fn[256];

	int		fbyte;
	int		i,j,k,l,m,p=0;


	f1=fopen(scfn,"rb");
	fbyte=getc(f1);	
	while(!feof(f1))
	{

		fi=0;for(i=0;i<5000;++i){fl[i]=0;for(j=0;j<1024;++j){fld[i][j]='\0';}}
		while(!feof(f1)&&fbyte!=13&&fbyte!=10){if(fbyte==9){++fi;}else{fld[fi][fl[fi]]=fbyte;++fl[fi];}fbyte=getc(f1);}
		while(!feof(f1)&&fbyte==13||fbyte==10){fbyte=getc(f1);}
		
		if(p==lv){l=0;for(i=0;i<strlen(fld[0]);++i){al[l]=fld[0][i];++l;}}
		if(p==uv){l=0;for(i=0;i<strlen(fld[0]);++i){au[l]=fld[0][i];++l;}break;}
		++p;
	}
	fclose(f1);

	return(0);

}

int	p_1()
{

	char	p_fn[256];

	int		fbyte;
	int		i,j,k,l,m,p;


	f1=fopen(infn,"rb");
	fbyte=getc(f1);	
	while(!feof(f1))
	{

		fi=0;for(i=0;i<5000;++i){fl[i]=0;for(j=0;j<1024;++j){fld[i][j]='\0';}}
		while(!feof(f1)&&fbyte!=13&&fbyte!=10){if(fbyte==9){++fi;}else{fld[fi][fl[fi]]=fbyte;++fl[fi];}fbyte=getc(f1);}
		while(!feof(f1)&&fbyte==13||fbyte==10){fbyte=getc(f1);}

		//printf("%s\t%s\t%e\t%e\t%e\n",fld[5],fld[3],p_val(fld[3]),p_val(al11),p_val(au11));

		if(fld[5][0]=='4'&&fld[5][1]=='4')
		{
			if((p_val(fld[3])>=p_val(al11))&&(p_val(fld[3])<=p_val(au11)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='3'&&fld[5][1]=='1'&&fld[5][2]=='8')
		{
			if((p_val(fld[3])>=p_val(al12))&&(p_val(fld[3])<=p_val(au12)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='3'&&fld[5][1]=='0'&&fld[5][2]=='2')
		{
			if((p_val(fld[3])>=p_val(al13))&&(p_val(fld[3])<=p_val(au13)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='3'&&fld[5][1]=='7'&&fld[5][2]=='0')
		{
			if((p_val(fld[3])>=p_val(al14))&&(p_val(fld[3])<=p_val(au14)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='3'&&fld[5][1]=='5'&&fld[5][2]=='8')
		{
			if((p_val(fld[3])>=p_val(al15))&&(p_val(fld[3])<=p_val(au15)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='3'&&fld[5][1]=='5'&&fld[5][2]=='2')
		{
			if((p_val(fld[3])>=p_val(al16))&&(p_val(fld[3])<=p_val(au16)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='9'&&fld[5][1]=='0'&&fld[5][2]=='\0')
		{
			if((p_val(fld[3])>=p_val(al17))&&(p_val(fld[3])<=p_val(au17)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='4'&&fld[5][1]=='2'&&fld[5][2]=='\0')
		{
			if((p_val(fld[3])>=p_val(al18))&&(p_val(fld[3])<=p_val(au18)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='2'&&fld[5][1]=='3'&&fld[5][2]=='0')
		{
			if((p_val(fld[3])>=p_val(al19))&&(p_val(fld[3])<=p_val(au19)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='2'&&fld[5][1]=='2'&&fld[5][2]=='0')
		{
			if((p_val(fld[3])>=p_val(al110))&&(p_val(fld[3])<=p_val(au110)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='2'&&fld[5][1]=='1'&&fld[5][2]=='8')
		{
			if((p_val(fld[3])>=p_val(al111))&&(p_val(fld[3])<=p_val(au111)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='2'&&fld[5][1]=='6'&&fld[5][2]=='0')
		{
			if((p_val(fld[3])>=p_val(al112))&&(p_val(fld[3])<=p_val(au112)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='2'&&fld[5][1]=='5'&&fld[5][2]=='8')
		{
			if((p_val(fld[3])>=p_val(al113))&&(p_val(fld[3])<=p_val(au113)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='9'&&fld[5][1]=='2'&&fld[5][2]=='\0')
		{
			if((p_val(fld[3])>=p_val(al114))&&(p_val(fld[3])<=p_val(au114)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='4'&&fld[5][1]=='0'&&fld[5][2]=='\0')
		{
			if((p_val(fld[3])>=p_val(al115))&&(p_val(fld[3])<=p_val(au115)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='1'&&fld[5][1]=='0'&&fld[5][2]=='8')
		{
			if((p_val(fld[3])>=p_val(al116))&&(p_val(fld[3])<=p_val(au116)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='1'&&fld[5][1]=='4'&&fld[5][2]=='8')
		{
			if((p_val(fld[3])>=p_val(al117))&&(p_val(fld[3])<=p_val(au117)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='1'&&fld[5][1]=='2'&&fld[5][2]=='8')
		{
			if((p_val(fld[3])>=p_val(al118))&&(p_val(fld[3])<=p_val(au118)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}

		if(fld[5][0]=='1'&&fld[5][1]=='3'&&fld[5][2]=='0')
		{
			if((p_val(fld[3])>=p_val(al119))&&(p_val(fld[3])<=p_val(au119)))
			{
				for(i=0;i<=fi;++i){for(j=0;j<strlen(fld[i]);++j){printf("%c",fld[i][j]);}printf("%c",(char)9);}printf("%c%c",(char)13,(char)10);
			}
		}


	}
	fclose(f1);

	return(0);
}


int main()
{

	int		fbyte;
	int		i,j,k,l,m;
	int		a,b;

	char	cv[256];

	for(i=0;i<256;++i){al11[i]='\0';}for(i=0;i<256;++i){au11[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_1\\xd.txt",70,125,al11,au11);
	printf("%s\t%s\n",al11,au11);

	for(i=0;i<256;++i){al12[i]='\0';}for(i=0;i<256;++i){au12[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_2\\xd.txt",70,125,al12,au12);
	printf("%s\t%s\n",al12,au12);

	for(i=0;i<256;++i){al13[i]='\0';}for(i=0;i<256;++i){au13[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_3\\xd.txt",70,125,al13,au13);
	printf("%s\t%s\n",al13,au13);

	for(i=0;i<256;++i){al14[i]='\0';}for(i=0;i<256;++i){au14[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_4\\xd.txt",70,125,al14,au14);
	printf("%s\t%s\n",al14,au14);

	for(i=0;i<256;++i){al15[i]='\0';}for(i=0;i<256;++i){au15[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_5\\xd.txt",70,125,al15,au15);
	printf("%s\t%s\n",al15,au15);

	for(i=0;i<256;++i){al16[i]='\0';}for(i=0;i<256;++i){au16[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_6\\xd.txt",70,125,al16,au16);
	printf("%s\t%s\n",al16,au16);

	for(i=0;i<256;++i){al17[i]='\0';}for(i=0;i<256;++i){au17[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_7\\xd.txt",70,125,al17,au17);
	printf("%s\t%s\n",al17,au17);

	for(i=0;i<256;++i){al18[i]='\0';}for(i=0;i<256;++i){au18[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_8\\xd.txt",70,125,al18,au18);
	printf("%s\t%s\n",al18,au18);

	for(i=0;i<256;++i){al19[i]='\0';}for(i=0;i<256;++i){au19[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_9\\xd.txt",70,125,al19,au19);
	printf("%s\t%s\n",al19,au19);

	for(i=0;i<256;++i){al110[i]='\0';}for(i=0;i<256;++i){au110[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_a10\\xd.txt",70,125,al110,au110);
	printf("%s\t%s\n",al110,au110);

	for(i=0;i<256;++i){al111[i]='\0';}for(i=0;i<256;++i){au111[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_a11\\xd.txt",70,125,al111,au111);
	printf("%s\t%s\n",al111,au111);

	for(i=0;i<256;++i){al112[i]='\0';}for(i=0;i<256;++i){au112[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_a12\\xd.txt",70,125,al112,au112);
	printf("%s\t%s\n",al112,au112);

	for(i=0;i<256;++i){al113[i]='\0';}for(i=0;i<256;++i){au113[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_a13\\xd.txt",70,125,al113,au113);
	printf("%s\t%s\n",al113,au113);

	for(i=0;i<256;++i){al114[i]='\0';}for(i=0;i<256;++i){au114[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_a14\\xd.txt",70,125,al114,au114);
	printf("%s\t%s\n",al114,au114);

	for(i=0;i<256;++i){al115[i]='\0';}for(i=0;i<256;++i){au115[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_a15\\xd.txt",70,125,al115,au115);
	printf("%s\t%s\n",al115,au115);

	for(i=0;i<256;++i){al116[i]='\0';}for(i=0;i<256;++i){au116[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_a16\\xd.txt",70,125,al116,au116);
	printf("%s\t%s\n",al116,au116);

	for(i=0;i<256;++i){al117[i]='\0';}for(i=0;i<256;++i){au117[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_a17\\xd.txt",70,125,al117,au117);
	printf("%s\t%s\n",al117,au117);

	for(i=0;i<256;++i){al118[i]='\0';}for(i=0;i<256;++i){au118[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_a18\\xd.txt",70,125,al118,au118);
	printf("%s\t%s\n",al118,au118);

	for(i=0;i<256;++i){al119[i]='\0';}for(i=0;i<256;++i){au119[i]='\0';}
	p_2("F:\\lc_E1F4G1\\_5_a19\\xd.txt",70,125,al119,au119);
	printf("%s\t%s\n",al119,au119);

	p_1();

	return(0);

}
